package v1

import (
	"errors"
	"metawant.greentech.com.cn/gaoyagang/gt-common/datacenter_client"
	"metawant.greentech.com.cn/gaoyagang/gt-common/httplib"
	"strconv"
)

func (d *DcApi) FindAppList(params datacenter_client.FindAppListReq) (*datacenter_client.FindAppListResp, error) {
	serviceName := "/app/list"
	h := httplib.Get(d.serviceUrl(serviceName))
	h.Param("project_id", strconv.FormatInt(params.ProjectId, 10))
	h.Param("page", strconv.FormatInt(params.Page, 10))
	h.Param("page_size", strconv.FormatInt(params.PageSize, 10))
	h.Param("order", params.Order)

	resp := &datacenter_client.FindAppListResp{}

	err := d.call(h, resp)

	if resp.Code != 200 {
		return nil, errors.New(resp.Msg)
	}

	return resp, err
}
