package v1

import (
	"errors"
	"metawant.greentech.com.cn/gaoyagang/gt-common/datacenter_client"
	"metawant.greentech.com.cn/gaoyagang/gt-common/httplib"
	"strconv"
)

func (d *DcApi) FindEventList(params datacenter_client.FindEventListReq) (*datacenter_client.FindEventListResp, error) {
	serviceName := "/events"
	h := httplib.Get(d.serviceUrl(serviceName))

	h.Param("project_id", strconv.FormatInt(params.ProjectId, 10))
	h.Param("name", params.Name)
	h.Param("stime", params.Stime)
	h.Param("etime", params.Etime)
	h.Param("device_code", params.DeviceCode)
	h.Param("item", params.Item)

	resp := &datacenter_client.FindEventListResp{}

	err := d.call(h, resp)
	if err != nil {
		return nil, err
	}

	if resp.Code != 200 {
		return nil, errors.New(resp.Msg)
	}

	return resp, err
}
