package v1

import (
	"errors"
	"fmt"
	"metawant.greentech.com.cn/gaoyagang/gt-common/datacenter_client"
	"metawant.greentech.com.cn/gaoyagang/gt-common/httplib"
	"strconv"
)

func (d *DcApi) FindKyLink(params datacenter_client.FindKyLinkDataReq) (*datacenter_client.FindKyLinkDataResp, error) {
	serviceName := "/data/Kylink"
	h := httplib.Get(d.serviceUrl(serviceName))

	if params.PageSize <= 0 {
		params.PageSize = 50
	}

	if params.Page <= 1 {
		params.Page = 1
	}

	h.Param("project_id", strconv.FormatInt(params.ProjectId, 10))
	h.Param("customers", params.Customer)
	h.Param("stime", params.Stime)
	h.Param("etime", params.Etime)
	h.Param("only_even", fmt.Sprintf("%d", params.OnlyEven))
	h.Param("page", strconv.FormatInt(params.Page, 10))
	h.Param("page_size", strconv.FormatInt(params.PageSize, 10))
	h.Param("order", params.Order)

	resp := &datacenter_client.FindKyLinkDataResp{}

	err := d.call(h, resp)
	if err != nil {
		return nil, err
	}

	if resp.Code != 200 {
		return nil, errors.New(resp.Msg)
	}

	return resp, err
}
