package v1

import (
	"fmt"
	"metawant.greentech.com.cn/gaoyagang/gt-common/datacenter_client"
	"metawant.greentech.com.cn/gaoyagang/gt-common/httplib"
	"strconv"
)

func (d *DcApi) FindWorkingUfByCycle(params datacenter_client.FindWorkingUfByCycleReq) (*datacenter_client.FindWorkingUfByCycleResp, error) {
	serviceName := "/working-uf/cycle"
	h := httplib.Get(d.serviceUrl(serviceName))
	h.Param("project_id", strconv.FormatInt(params.ProjectId, 10))
	h.Param("device_code", params.DeviceCode)
	h.Param("filter_cycle", strconv.FormatInt(params.FilterCycle, 10))
	h.Param("step", strconv.FormatInt(params.Step, 10))
	h.Param("filter_time_start", fmt.Sprintf("%f", params.FilterTimeStart))
	h.Param("filter_time_end", fmt.Sprintf("%f", params.FilterTimeEnd))
	h.Param("limit", strconv.FormatInt(params.Limit, 10))

	resp := &datacenter_client.FindWorkingUfByCycleResp{}

	err := d.call(h, resp)
	return resp, err
}
