package v1

import (
	"errors"
	"metawant.greentech.com.cn/gaoyagang/gt-common/datacenter_client"
	"metawant.greentech.com.cn/gaoyagang/gt-common/httplib"
	"strconv"
)

func (d *DcApi) GetAppInfo(params datacenter_client.GetAppInfoReq) (*datacenter_client.GetAppInfoResp, error) {
	serviceName := "/app/info"
	h := httplib.Get(d.serviceUrl(serviceName))
	h.Param("project_id", strconv.FormatInt(params.ProjectId, 10))
	h.Param("app_name", params.AppName)

	resp := &datacenter_client.GetAppInfoResp{}

	err := d.call(h, resp)

	if resp.Code != 200 {
		return nil, errors.New(resp.Msg)
	}
	return resp, err
}
