package v1

import (
	"errors"
	"log"
	"metawant.greentech.com.cn/gaoyagang/gt-common/datacenter_client"
	"metawant.greentech.com.cn/gaoyagang/gt-common/httplib"
)

func (d *DcApi) GetItemHistory(req datacenter_client.ItemHistoryReq) (resp []datacenter_client.ItemHistoryResp, err error) {
	url := d.serviceUrl("/item-history/info")
	h := httplib.Get(url)
	h.Param("project_id", req.ProjectId)
	h.Param("item_name", req.ItemName)
	h.Param("stime", req.Stime)
	h.Param("etime", req.Etime)

	result := &datacenter_client.ItemHistoryBody{}
	err = d.call(h, result)
	if err != nil {
		log.Println("GetItemHistory Unmarshal Error:", err)
		return
	}
	if result.Code != 200 {
		err = errors.New(result.Msg)
		return
	}
	resp = result.Data.List
	return
}
