package v1

import (
	"errors"
	"fmt"
	"log"
	"metawant.greentech.com.cn/gaoyagang/gt-common/datacenter_client"
	"metawant.greentech.com.cn/gaoyagang/gt-common/httplib"
)

func (d *DcApi) GetItemHistoryList(req datacenter_client.ItemHistoryListReq) (resp []datacenter_client.ItemHistoryListResp, err error) {
	url := d.serviceUrl("/item-history/list")
	h := httplib.Get(url)
	h.Param("project_id", fmt.Sprintf("%d", req.ProjectId))
	h.Param("item_name", req.ItemName)
	h.Param("stime", req.Stime)
	h.Param("etime", req.Etime)
	h.Param("size", fmt.Sprintf("%d", req.Size))
	h.Param("interval", req.Interval)
	h.Param("aggregator", req.Aggregator)
	h.Param("max_val", fmt.Sprintf("%f", req.MaxVal))
	h.Param("min_val", fmt.Sprintf("%f", req.MinVal))

	result := &datacenter_client.ItemHistoryListBody{}
	err = d.call(h, result)
	if err != nil {
		log.Println("GetItemHistoryList Unmarshal Error:", err)
		return
	}
	if result.Code != 200 {
		err = errors.New(result.Msg)
		return
	}
	resp = result.Data.List
	return
}
