package v1

import (
	"metawant.greentech.com.cn/gaoyagang/gt-common/datacenter_client"
	"metawant.greentech.com.cn/gaoyagang/gt-common/httplib"
	"strconv"
)

func (d *DcApi) GetWorkingRoByCode(params datacenter_client.DcWorkingReq) (*datacenter_client.GetWorkingRoByCodeResp, error) {
	serviceName := "/working-ro/info"
	h := httplib.Get(d.serviceUrl(serviceName))
	h.Param("project_id", strconv.FormatInt(params.ProjectId, 10))
	h.Param("device_code", params.DeviceCode)
	h.Param("stime", params.Stime)
	h.Param("etime", params.Etime)
	h.Param("page", strconv.FormatInt(params.Page, 10))
	h.Param("page_size", strconv.FormatInt(params.PageSize, 10))
	h.Param("order", params.Order)

	resp := &datacenter_client.GetWorkingRoByCodeResp{}
	err := d.call(h, resp)
	return resp, err
}
