package v1

import (
	"errors"
	"fmt"
	"log"
	"metawant.greentech.com.cn/gaoyagang/gt-common/datacenter_client"
	"metawant.greentech.com.cn/gaoyagang/gt-common/httplib"
)

func (d *DcApi) MultiAddData(req datacenter_client.MultiAddReq) (err error) {
	if len(req.List) == 0 {
		return errors.New("无可插入数据")
	}
	url := d.serviceUrl("/item-history/multi-add")
	h := httplib.Post(url)
	h.Param("project_id", fmt.Sprintf("%d", req.List[0].ProjectId))
	_, err = h.JSONBody(req)
	if err != nil {
		return
	}

	result := &datacenter_client.ItemHistoryBody{}
	err = d.call(h, result)
	if err != nil {
		log.Println("GetItemHistory Error:", err)
		return
	}
	if result.Code != 200 {
		err = errors.New(result.Msg)
		return
	}
	return
}
