package v1

import (
	"errors"
	"metawant.greentech.com.cn/gaoyagang/gt-common/datacenter_client"
	"metawant.greentech.com.cn/gaoyagang/gt-common/httplib"
	"strconv"
)

func (d *DcApi) RemoveAppInfo(params datacenter_client.RemoveAppInfoReq) (*datacenter_client.RemoveAppInfoResp, error) {
	serviceName := "/app/remove"
	h := httplib.Post(d.serviceUrl(serviceName))
	h.Param("project_id", strconv.FormatInt(params.ProjectId, 10))

	_, err := h.JSONBody(params)
	if err != nil {
		return nil, err
	}

	resp := &datacenter_client.RemoveAppInfoResp{}

	err = d.call(h, resp)

	if resp.Code != 200 {
		return nil, errors.New(resp.Msg)
	}
	return resp, err
}
